diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
index 62a6702e..ad080bcf 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
@@ -490,354 +1289,49 @@ object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefini
     }
   })
 
-  private def memberCodec(pad : Int) : Codec[SquadPositionDetail2] = {
+  /**
+    * Pattern for reading all of the fields for squad position data.
+    * @param bitsOverByteLength the number of bits past the previous byte-aligned index
+    * @param defaultRequirements `CertificationType` values that are automatically masked in the `requirements` field
+    */
+  private def basePositionCodec(bitsOverByteLength : Int, defaultRequirements : Set[CertificationType.Value]) : Codec[SquadPositionDetail] = {
     import shapeless.::
     (
       uint8 :: //required value = 6
         ("is_closed" | bool) :: //if all positions are closed, the squad detail menu display no positions at all
-        ("role" | PacketHelpers.encodedWideStringAligned(pad)) ::
+        ("role" | paddedStringMetaCodec(bitsOverByteLength)) ::
         ("detailed_orders" | PacketHelpers.encodedWideString) ::
         ("char_id" | uint32L) ::
         ("name" | PacketHelpers.encodedWideString) ::
         ("requirements" | ulongL(46))
-      ).exmap[SquadPositionDetail2] (
+      ).exmap[SquadPositionDetail] (
       {
         case 6 :: closed :: role :: orders :: char_id :: name :: requirements :: HNil =>
           Attempt.Successful(
-            SquadPositionDetail2(Some(closed), Some(role), Some(orders), Some(DefaultRequirements ++ CertificationType.fromEncodedLong(requirements)), Some(char_id), Some(name))
+            SquadPositionDetail(Some(closed), Some(role), Some(orders), Some(defaultRequirements ++ CertificationType.fromEncodedLong(requirements)), Some(char_id), Some(name))
           )
         case data =>
           Attempt.Failure(Err(s"can not decode a SquadDetailDefinitionUpdate member's data - $data"))
       },
       {
-        case SquadPositionDetail2(Some(closed), Some(role), Some(orders), Some(requirements), Some(char_id), Some(name)) =>
-          Attempt.Successful(6 :: closed :: role :: orders :: char_id :: name :: CertificationType.toEncodedLong(DefaultRequirements ++ requirements) :: HNil)
+        case SquadPositionDetail(Some(closed), Some(role), Some(orders), Some(requirements), Some(char_id), Some(name)) =>
+          Attempt.Successful(6 :: closed :: role :: orders :: char_id :: name :: CertificationType.toEncodedLong(defaultRequirements ++ requirements) :: HNil)
       }
     )
   }
 
-  private val first_member_codec : Codec[SquadPositionDetail2] = memberCodec(pad = 7)
-
-  private val member_codec : Codec[SquadPositionDetail2] = memberCodec(pad = 0)
-
-  private case class LinkedMemberList(member : SquadPositionDetail2, next : Option[LinkedMemberList])
-
-  private def subsequent_member_codec : Codec[LinkedMemberList] = {
-    import shapeless.::
-    (
-      //disruptive coupling action (e.g., flatPrepend) is necessary to allow for recursive Codec
-      ("member" | member_codec) >>:~ { _ =>
-        optional(bool, "next" | subsequent_member_codec).hlist
-      }
-      ).xmap[LinkedMemberList] (
-      {
-        case a :: b :: HNil =>
-          LinkedMemberList(a, b)
-      },
-      {
-        case LinkedMemberList(a, b) =>
-          a :: b :: HNil
-      }
-    )
-  }
-
-  private def initial_member_codec : Codec[LinkedMemberList] = {
-    import shapeless.::
-    (
-      ("member" | first_member_codec) ::
-        optional(bool, "next" | subsequent_member_codec)
-      ).xmap[LinkedMemberList] (
-      {
-        case a :: b :: HNil =>
-          LinkedMemberList(a, b)
-      },
-      {
-        case LinkedMemberList(a, b) =>
-          a :: b :: HNil
-      }
-    )
-  }
-
-  @tailrec
-  private def unlinkMemberList(list : LinkedMemberList, out : List[SquadPositionDetail2] = Nil) : List[SquadPositionDetail2] = {
-    list.next match {
-      case None =>
-        out :+ list.member
-      case Some(next) =>
-        unlinkMemberList(next, out :+ list.member)
-    }
-  }
-
-  private def linkMemberList(list : List[SquadPositionDetail2]) : LinkedMemberList = {
-    list match {
-      case Nil =>
-        throw new Exception("")
-      case x :: Nil =>
-        LinkedMemberList(x, None)
-      case x :: xs =>
-        linkMemberList(xs, LinkedMemberList(x, None))
-    }
-  }
-
-  @tailrec
-  private def linkMemberList(list : List[SquadPositionDetail2], out : LinkedMemberList) : LinkedMemberList = {
-    list match {
-      case Nil =>
-        out
-      case x :: Nil =>
-        LinkedMemberList(x, Some(out))
-      case x :: xs =>
-        linkMemberList(xs, LinkedMemberList(x, Some(out)))
-    }
-  }
-
-  val full_squad_detail_codec : Codec[SquadDetail] = {
-    import shapeless.::
-    (
-      ("unk1" | uint8) ::
-        ("unk2" | uint24) :: //unknown, but can be 0'd
-        ("leader_char_id" | uint32L) ::
-        ("unk3" | uint32L) :: //variable fields, but can be 0'd
-        ("leader" | PacketHelpers.encodedWideStringAligned(7)) ::
-        ("task" | PacketHelpers.encodedWideString) ::
-        ("zone_id" | PlanetSideZoneID.codec) ::
-        ("unk7" | uint(23)) :: //during full squad mode, constant = 4983296
-        optional(bool, "member_info" | initial_member_codec)
-      ).exmap[SquadDetail] (
-      {
-        case u1 :: u2 :: char_id :: u3 :: leader :: task :: zone :: unk7 :: Some(member_list) :: HNil =>
-          Attempt.Successful(
-            SquadDetail(Some(u1), Some(u2), Some(char_id), Some(u3), Some(leader), Some(task), Some(zone), Some(unk7),
-              Some(unlinkMemberList(member_list).zipWithIndex.map { case (entry, index) => SquadPositionEntry(index, Some(entry)) })
-            )
-          )
-        case data =>
-          Attempt.failure(Err(s"can not get squad detail definition from data $data"))
-      },
-      {
-        case SquadDetail(Some(u1), Some(u2), Some(char_id), Some(u3), Some(leader), Some(task), Some(zone), Some(unk7), Some(member_list)) =>
-          Attempt.Successful(
-            math.max(u1, 1) :: u2 :: char_id :: u3 :: leader :: task :: zone :: unk7 ::
-              Some(linkMemberList(member_list.collect { case SquadPositionEntry(_, Some(entry)) => entry }.reverse)) ::
-              HNil
-          )
-      }
-    )
-  }
-
-  private val field1Codec : Codec[SquadDetail] = uint16L.exmap[SquadDetail] (
-    unk1 => Attempt.successful(SquadDetail(Some(unk1), None, None, None, None, None, None, None, None)),
-    {
-      case SquadDetail(Some(unk1), _, _, _,  _, _, _, _, _) =>
-        Attempt.successful(unk1)
-      case _ =>
-        Attempt.failure(Err("failed to encode squad data for unknown field #1"))
-    }
-  )
-
-  private val leaderCharIdCodec : Codec[SquadDetail] = uint32L.exmap[SquadDetail] (
-    char_id => Attempt.successful(SquadDetail(char_id)),
-    {
-      case SquadDetail(_, _, Some(char_id), _,  _, _, _, _, _) =>
-        Attempt.successful(char_id)
-      case _ =>
-        Attempt.failure(Err("failed to encode squad data for leader id"))
-    }
-  )
-
-  private val field3Codec : Codec[SquadDetail] = uint32L.exmap[SquadDetail] (
-    unk3 => Attempt.successful(SquadDetail(None, None, None, Some(unk3), None, None, None, None, None)),
-    {
-      case SquadDetail(_, _, _, Some(unk3),  _, _, _, _, _) =>
-        Attempt.successful(unk3)
-      case _ =>
-        Attempt.failure(Err("failed to encode squad data for unknown field #3"))
-    }
-  )
-
-  private def leaderNameCodec(bitsOverByte : StreamLengthToken) : Codec[SquadDetail] = paddedStringMetaCodec(bitsOverByte.Length).exmap[SquadDetail] (
-    name => Attempt.successful(SquadDetail(name, None)),
-    {
-      case SquadDetail(_, _, _, _, Some(name), _, _, _, _) =>
-        Attempt.successful(name)
-      case _ =>
-        Attempt.failure(Err("failed to encode squad data for leader name"))
-    }
-  )
-
-  private def taskCodec(bitsOverByte : StreamLengthToken) : Codec[SquadDetail] = paddedStringMetaCodec(bitsOverByte.Length).exmap[SquadDetail] (
-    task => Attempt.successful(SquadDetail(None, task)),
-    {
-      case SquadDetail(_, _, _, _, _, Some(task), _, _, _) =>
-        Attempt.successful(task)
-      case _ =>
-        Attempt.failure(Err("failed to encode squad data for task"))
-    }
-  )
-
-  private val zoneCodec : Codec[SquadDetail] = PlanetSideZoneID.codec.exmap[SquadDetail] (
-    zone_id => Attempt.successful(SquadDetail(zone_id)),
-    {
-      case SquadDetail(_, _, _, _, _, _, Some(zone_id), _, _) =>
-        Attempt.successful(zone_id)
-      case _ =>
-        Attempt.failure(Err("failed to encode squad data for zone id"))
-    }
-  )
-
-  private val field7Codec : Codec[SquadDetail] = {
-    uint4.exmap[SquadDetail] (
-      unk7 => Attempt.successful(SquadDetail(None, None, None, None, None, None, None, Some(unk7), None)),
-      {
-        case SquadDetail(_, _, _,  _, _, _, _, Some(unk7), _) =>
-          Attempt.successful(unk7)
-        case _ =>
-          Attempt.failure(Err("failed to encode squad data for unknown field #7"))
-      }
-    )
-  }
-
-  private def membersCodec(bitsOverByte : StreamLengthToken) : Codec[SquadDetail] = {
-    import shapeless.::
-    bitsOverByte.Add(4)
-    (
-      uint4 :: //constant = 12
-        vector(SquadPositionEntry.codec(bitsOverByte))
-      ).exmap[SquadDetail] (
-      {
-        case 12 :: member_list :: HNil =>
-          Attempt.successful(SquadDetail(member_list.toList))
-      },
-      {
-        case SquadDetail(_, _, _, _, _, _, _, _, Some(member_list)) =>
-          Attempt.successful(12 :: member_list.toVector :: HNil)
-        case _ =>
-          Attempt.failure(Err("failed to encode squad data for members"))
-      }
-    )
-  }
-
-  private val failureCodec : Codec[SquadDetail] = conditional(included = false, bool).exmap[SquadDetail] (
-    _ => Attempt.failure(Err("decoding with unhandled codec")),
-    _ => Attempt.failure(Err("encoding with unhandled codec"))
-  )
-
-  private def selectCodecAction(code : Int, bitsOverByte : StreamLengthToken) : Codec[SquadDetail] = {
-    code match {
-      case 1 => field1Codec
-      case 2 => leaderCharIdCodec
-      case 3 => field3Codec
-      case 4 => leaderNameCodec(bitsOverByte)
-      case 5 => taskCodec(bitsOverByte)
-      case 6 => zoneCodec
-      case 7 => field7Codec
-      case 8 => membersCodec(bitsOverByte)
-      case _ => failureCodec
-    }
-  }
-
-  private def modifyCodecPadValue(code : Int, bitsOverByte : StreamLengthToken) : StreamLengthToken = {
-    code match {
-      case 1 => bitsOverByte //16u = no added padding
-      case 2 => bitsOverByte //32u = no added padding
-      case 3 => bitsOverByte //32u = no added padding
-      case 4 => bitsOverByte.Length = 0 //byte-aligned string; padding zero'd
-      case 5 => bitsOverByte.Length = 0 //byte-aligned string; padding zero'd
-      case 6 => bitsOverByte //32u = no added padding
-      case 7 => bitsOverByte.Add(4) //additional 4u
-      case 8 => bitsOverByte.Length = 0 //end of stream
-      case _ => bitsOverByte.Length = Int.MinValue //wildly incorrect
-    }
-  }
-
-  private final case class LinkedSquadInfo(code : Int, info : SquadDetail, next : Option[LinkedSquadInfo])
-
-  private def unlinkSquadInfo(info : LinkedSquadInfo) : SquadDetail = unlinkSquadInfo(Some(info))
-
-  @tailrec
-  private def unlinkSquadInfo(info : Option[LinkedSquadInfo], squadInfo : SquadDetail = SquadDetail.Blank) : SquadDetail = {
-    info match {
-      case None =>
-        squadInfo
-      case Some(sqInfo) =>
-        unlinkSquadInfo(sqInfo.next, squadInfo And sqInfo.info)
-    }
-  }
-
-  private def linkSquadInfo(info : SquadDetail) : LinkedSquadInfo = {
-    //import scala.collection.immutable.::
-    Seq(
-      (8, SquadDetail(None, None, None, None, None, None, None, None, info.member_info)),
-      (7, SquadDetail(None, None, None, None, None, None, None, info.unk7, None)),
-      (6, SquadDetail(None, None, None, None, None, None, info.zone_id, None, None)),
-      (5, SquadDetail(None, None, None, None, None, info.task, None, None, None)),
-      (4, SquadDetail(None, None, None, None, info.leader_name, None, None, None, None)),
-      (3, SquadDetail(None, None, None, info.unk3, None, None, None, None, None)),
-      (2, SquadDetail(None, None, info.leader_char_id, None, None, None, None, None, None)),
-      (1, SquadDetail(info.unk1, None, None, None, None, None, None, None, None))
-    ) //in reverse order so that the linked list is in the correct order
-      .filterNot { case (_, sqInfo) => sqInfo == SquadDetail.Blank}
-    match {
-      case Nil =>
-        throw new Exception("no linked list squad fields encountered where at least one was expected") //bad end
-      case x :: Nil =>
-        val (code, squadInfo) = x
-        LinkedSquadInfo(code, squadInfo, None)
-      case x :: xs =>
-        val (code, squadInfo) = x
-        linkSquadInfo(xs, LinkedSquadInfo(code, squadInfo, None))
-    }
-  }
-
-  @tailrec
-  private def linkSquadInfo(infoList : Seq[(Int, SquadDetail)], linkedInfo : LinkedSquadInfo) : LinkedSquadInfo = {
-    if(infoList.isEmpty) {
-      linkedInfo
-    }
-    else {
-      val (code, data) = infoList.head
-      linkSquadInfo(infoList.tail, LinkedSquadInfo(code, data, Some(linkedInfo)))
-    }
-  }
-
-  private def linked_squad_detail_codec(size : Int, bitsOverByte : StreamLengthToken) : Codec[LinkedSquadInfo] = {
-    import shapeless.::
-    (
-      uint4 >>:~ { code =>
-        selectCodecAction(code, bitsOverByte.Add(4)) ::
-          conditional(size - 1 > 0, linked_squad_detail_codec(size - 1, modifyCodecPadValue(code, bitsOverByte)))
-      }
-      ).exmap[LinkedSquadInfo] (
-      {
-        case action :: detail :: next :: HNil =>
-          Attempt.Successful(LinkedSquadInfo(action, detail, next))
-      },
-      {
-        case LinkedSquadInfo(action, detail, next) =>
-          Attempt.Successful(action :: detail :: next :: HNil)
-      }
-    )
-  }
-
-  def squadDetailSelectCodec(size : Int) : Codec[SquadDetail] = {
-    if(size == 9) {
-      full_squad_detail_codec
-    }
-    else {
-      linked_squad_detail_codec(size, new StreamLengthToken(1)).xmap[SquadDetail] (
-        linkedDetail => unlinkSquadInfo(linkedDetail),
-        unlinkedDetail => linkSquadInfo(unlinkedDetail)
-      )
-    }
-  }
-
   implicit val codec : Codec[SquadDetailDefinitionUpdateMessage] = {
     import shapeless.::
+    import net.psforever.newcodecs.newcodecs
     (
       ("guid" | PlanetSideGUID.codec) ::
         bool ::
         (uint8 >>:~ { size =>
-          squadDetailSelectCodec(size).hlist
+          newcodecs.binary_choice(
+            size == 9,
+            FullSquad.codec,
+            ItemizedSquad.codec(size)
+          ).hlist
         })
       ).exmap[SquadDetailDefinitionUpdateMessage] (
       {
@@ -853,27 +1347,8 @@ object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefini
             Attempt.Successful(guid :: true :: occupiedSquadFieldCount :: info :: HNil)
           }
           else {
-            info.member_info match {
-              case Some(list) =>
-                if(list.size == 10 &&
-                list
-                  .collect { case position if position.info.nonEmpty =>
-                    val info = position.info.get
-                    List(info.is_closed, info.role, info.detailed_orders, info.requirements, info.char_id, info.name)
-                  }
-                  .flatten
-                  .count(_.isEmpty) == 0) {
-                  //full squad detail definition protocol
-                  Attempt.Successful(guid :: true :: 9 :: info :: HNil)
-                }
-                else {
-                  //unhandled state
-                  Attempt.Failure(Err("can not split encoding patterns - all squad fields are defined but not all squad member fields are defined"))
-                }
-              case None =>
-                //impossible?
-                Attempt.Failure(Err("the members field can not be empty; the existence of this field was already proven"))
-            }
+            //full squad detail definition protocol
+            Attempt.Successful(guid :: true :: 9 :: info :: HNil)
           }
       }
     )
diff --git a/common/src/main/scala/services/teamwork/SquadResponse.scala b/common/src/main/scala/services/teamwork/SquadResponse.scala
index b898580b..27ef6dcd 100644
--- a/common/src/main/scala/services/teamwork/SquadResponse.scala
+++ b/common/src/main/scala/services/teamwork/SquadResponse.scala
@@ -1,7 +1,7 @@
 // Copyright (c) 2019 PSForever
 package services.teamwork
 
-import net.psforever.packet.game.{PlanetSideGUID, PlanetSideZoneID, SquadInfo, SquadPositionDetail}
+import net.psforever.packet.game._
 
 object SquadResponse {
   trait Response
diff --git a/pslogin/src/main/scala/WorldSessionActor.scala b/pslogin/src/main/scala/WorldSessionActor.scala
index 83d290f8..7aa34958 100644
--- a/pslogin/src/main/scala/WorldSessionActor.scala
+++ b/pslogin/src/main/scala/WorldSessionActor.scala
@@ -375,11 +375,15 @@ class WorldSessionActor extends Actor with MDCContextAware {
           sendResponse(
             SquadDetailDefinitionUpdateMessage(
               guid,
-              member_info.find(_.name == leader).get.char_id,
-              leader,
-              task,
-              zone,
-              member_info
+              SquadDetail()
+                .LeaderCharId(member_info.find(_.name == leader).get.char_id.get)
+                .LeaderName(leader)
+                .Task(task)
+                .ZoneId(zone)
+                .Members(
+                  member_info.zipWithIndex.map { case (a, b) => SquadPositionEntry(b, a) }
+                )
+                .Complete
             )
           )
         case _ => ;
@@ -2929,17 +2933,16 @@ class WorldSessionActor extends Actor with MDCContextAware {
           PlanetSideZoneID(7),
           4983296,
           List(
-            SquadPositionEntry(0, SquadPositionDetail2("\\#ff0000 |||||||||||||||||||||||", "", Set(), 0, "")),
-            SquadPositionEntry(1, SquadPositionDetail2("\\#ffdc00   C", "", Set(), 0, "")),
-            SquadPositionEntry(2, SquadPositionDetail2("\\#ffdc00   H", "", Set(), 42644970L, "OpolE")),
-            SquadPositionEntry(3, SquadPositionDetail2("\\#ffdc00    I", "", Set(), 41604210L, "BobaF3tt907")),
-            SquadPositionEntry(4, SquadPositionDetail2("\\#ffdc00   N", "", Set(), 0, "")),
-            SquadPositionEntry(5, SquadPositionDetail2("\\#ffdc00   A", "", Set(), 0, "")),
-//            SquadPositionEntry(6, SquadPositionDetail2("\\#ff0000 |||||||||||||||||||||||", "", Set(), 0, "")),
-            SquadPositionEntry(6, SquadPositionDetail2("\\#ff0000 |||||||||||||||||||||||", "", Set(), 1, "Test")),
-            SquadPositionEntry(7, SquadPositionDetail2("\\#9640ff   K", "", Set(), 0, "")),
-            SquadPositionEntry(8, SquadPositionDetail2("\\#9640ff   O", "", Set(), 42771010L ,"HofD")),
-            SquadPositionEntry(9, SquadPositionDetail2("\\#9640ff   K", "", Set(), 0, ""))
+            SquadPositionEntry(0, SquadPositionDetail("\\#ff0000 |||||||||||||||||||||||", "", Set(), 0, "")),
+            SquadPositionEntry(1, SquadPositionDetail("\\#ffdc00   C", "", Set(), 0, "")),
+            SquadPositionEntry(2, SquadPositionDetail("\\#ffdc00   H", "", Set(), 42644970L, "OpolE")),
+            SquadPositionEntry(3, SquadPositionDetail("\\#ffdc00    I", "", Set(), 41604210L, "BobaF3tt907")),
+            SquadPositionEntry(4, SquadPositionDetail("\\#ffdc00   N", "", Set(), 0, "")),
+            SquadPositionEntry(5, SquadPositionDetail("\\#ffdc00   A", "", Set(), 0, "")),
+            SquadPositionEntry(6, SquadPositionDetail("\\#ff0000 |||||||||||||||||||||||", "", Set(), 0, "")),
+            SquadPositionEntry(7, SquadPositionDetail("\\#9640ff   K", "", Set(), 0, "")),
+            SquadPositionEntry(8, SquadPositionDetail("\\#9640ff   O", "", Set(), 42771010L ,"HofD")),
+            SquadPositionEntry(9, SquadPositionDetail("\\#9640ff   K", "", Set(), 0, ""))
           )
         )
       )

